## errorship          

[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://gitlab.com/errorship/errorship_python)      
[![python versions](https://img.shields.io/badge/python-2.7%20%7C%203.*-blue)](https://img.shields.io/badge/python-2.7%20%7C%203.*-blue)      
[![codecov](https://codecov.io/gl/errorship/errorship_python/branch/master/graph/badge.svg?token=bTRTSMv0ji)](https://gitlab.com/errorship/errorship_python)    
[![pipeline status](https://gitlab.com/errorship/errorship_python/badges/master/pipeline.svg)](https://gitlab.com/errorship/errorship_python/-/commits/master)   
    
  
 
`errorship` is a python library that sends exceptions/errors generated by your application to your datadog account.    
The exceptions together with their stacktraces are then rendered beatifully with proper syntax highlighting preserved.     
You can search for exceptions in datadog using the tags that you had set or via full text search.     
Are you tired of looking at metrics in datadog and then switching over to another website to track your applications exceptions?    
Try [`errorship`](https://errorship.com)   

`errorship` has no third-party dependencies.  
It works in both Python 2 & python 3   


[Click here for Documentation](https://errorship.com/documentation.html)


## Installation

```shell
pip install errorship
```           


## Usage
Add the following piece of code at a place where it can be executed very early at the startup of your application.     
Such a place can be in an `__init__.py` file or at the top of your `main.py` file.   

```python
import errorship

errorship.setup(
    datadog_agent_host="localhost",
    datadog_agent_port=8125,
    errorship_license_key="MyErrorshipLicenseKey",
    tags={
        # this tags will be added to the errors/exceptions
        # that are sent to datadog
        "env": "production",
        "project": "accounting",
        "deployment_version": "v12.56"
    }
)
```    

More documentation is [available](https://errorship.com/documentation.html)     
    

## Screenshots  
Errors, exceptions, stacktraces and associated metadata as rendered in datadog;        
   
![errorship rendered exceptions in datadog](./examples/screenshots/datadog_exception.png "errorship rendered exceptions in datadog")          
   
![errorship rendered exceptions in datadog](./examples/screenshots/tutorial-main-error.png "errorship rendered exceptions in datadog")       
   
![errorship rendered exceptions in datadog](./examples/screenshots/tutorial-search-by-tags.png "errorship rendered exceptions in datadog")       
   
![errorship rendered exceptions in datadog](./examples/screenshots/tutorial-search-by-text.png "errorship rendered exceptions in datadog")       

